#ifndef EFL_IO_BUFFERED_STREAM_EO_HH
#define EFL_IO_BUFFERED_STREAM_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_buffered_stream.eo.h"
#include "efl_io_closer.eo.h"
#include "efl_io_reader.eo.h"
#include "efl_io_writer.eo.h"
#include "efl_loop.eo.h"
#include "efl_loop_user.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_io_closer.eo.hh"
#include "efl_io_reader.eo.hh"
#include "efl_io_writer.eo.hh"
#include "efl_loop.eo.hh"
#include "efl_loop_user.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace io { 
struct Buffered_Stream;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Buffered_Stream> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Buffered_Stream;
} } 
namespace efl { 
struct Loop_User;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Loop;
} 
namespace efl { namespace io { 
struct Reader;
} } 
namespace efl { namespace io { 
struct Writer;
} } 
namespace efl { namespace io { 
struct Closer;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Buffered_Stream {
   ::efl::eolian::return_traits< ::efl::Object>::type inner_io_get() const;
   ::efl::eolian::return_traits<void>::type inner_io_set( ::efl::eolian::in_traits< ::efl::Object>::type io) const;
   ::efl::eolian::return_traits< size_t>::type max_queue_size_input_get() const;
   ::efl::eolian::return_traits<void>::type max_queue_size_input_set( ::efl::eolian::in_traits< size_t>::type max_queue_size_input) const;
   ::efl::eolian::return_traits< size_t>::type max_queue_size_output_get() const;
   ::efl::eolian::return_traits<void>::type max_queue_size_output_set( ::efl::eolian::in_traits< size_t>::type max_queue_size_output) const;
   ::efl::eolian::return_traits<Eina_Slice>::type line_delimiter_get() const;
   ::efl::eolian::return_traits<void>::type line_delimiter_set( ::efl::eolian::in_traits<Eina_Slice>::type slice) const;
   ::efl::eolian::return_traits<double>::type timeout_inactivity_get() const;
   ::efl::eolian::return_traits<void>::type timeout_inactivity_set( ::efl::eolian::in_traits<double>::type seconds) const;
   ::efl::eolian::return_traits< size_t>::type read_chunk_size_get() const;
   ::efl::eolian::return_traits<void>::type read_chunk_size_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type pending_write_get() const;
   ::efl::eolian::return_traits< size_t>::type pending_read_get() const;
   ::efl::eolian::return_traits<void>::type progress_get( ::efl::eolian::out_traits< size_t>::type read_bytes,  ::efl::eolian::out_traits< size_t>::type written_bytes) const;
   ::efl::eolian::return_traits<Eina_Slice>::type slice_get() const;
   ::efl::eolian::return_traits<void>::type discard( ::efl::eolian::in_traits< size_t>::type amount) const;
   ::efl::eolian::return_traits<void>::type clear() const;
   ::efl::eolian::return_traits<void>::type eos_mark() const;
   ::efl::eolian::return_traits<bool>::type flush( ::efl::eolian::in_traits<bool>::type may_block,  ::efl::eolian::in_traits<bool>::type ignore_line_delimiter) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_BUFFERED_STREAM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Buffered_Stream() const;
   operator ::efl::io::Buffered_Stream&();
   operator ::efl::io::Buffered_Stream const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Buffered_Stream,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Reader,  ::efl::io::Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Buffered_Stream const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Reader const ,  ::efl::io::Writer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Buffered_Stream : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Loop_User)
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::io::Closer)
   , EO_CXX_INHERIT( ::efl ::io::Reader)
   , EO_CXX_INHERIT( ::efl ::io::Writer)
{
   explicit Buffered_Stream( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Buffered_Stream(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Buffered_Stream(Buffered_Stream const& other) = default;
   Buffered_Stream(Buffered_Stream&& other) = default;
   Buffered_Stream& operator=(Buffered_Stream const& other) = default;
   Buffered_Stream& operator=(Buffered_Stream&& other) = default;
   Buffered_Stream()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Buffered_Stream( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Buffered_Stream(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< ::efl::Object>::type inner_io_get() const;
   ::efl::eolian::return_traits<void>::type inner_io_set( ::efl::eolian::in_traits< ::efl::Object>::type io) const;
   ::efl::eolian::return_traits< size_t>::type max_queue_size_input_get() const;
   ::efl::eolian::return_traits<void>::type max_queue_size_input_set( ::efl::eolian::in_traits< size_t>::type max_queue_size_input) const;
   ::efl::eolian::return_traits< size_t>::type max_queue_size_output_get() const;
   ::efl::eolian::return_traits<void>::type max_queue_size_output_set( ::efl::eolian::in_traits< size_t>::type max_queue_size_output) const;
   ::efl::eolian::return_traits<Eina_Slice>::type line_delimiter_get() const;
   ::efl::eolian::return_traits<void>::type line_delimiter_set( ::efl::eolian::in_traits<Eina_Slice>::type slice) const;
   ::efl::eolian::return_traits<double>::type timeout_inactivity_get() const;
   ::efl::eolian::return_traits<void>::type timeout_inactivity_set( ::efl::eolian::in_traits<double>::type seconds) const;
   ::efl::eolian::return_traits< size_t>::type read_chunk_size_get() const;
   ::efl::eolian::return_traits<void>::type read_chunk_size_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type pending_write_get() const;
   ::efl::eolian::return_traits< size_t>::type pending_read_get() const;
   ::efl::eolian::return_traits<void>::type progress_get( ::efl::eolian::out_traits< size_t>::type read_bytes,  ::efl::eolian::out_traits< size_t>::type written_bytes) const;
   ::efl::eolian::return_traits<Eina_Slice>::type slice_get() const;
   ::efl::eolian::return_traits<void>::type discard( ::efl::eolian::in_traits< size_t>::type amount) const;
   ::efl::eolian::return_traits<void>::type clear() const;
   ::efl::eolian::return_traits<void>::type eos_mark() const;
   ::efl::eolian::return_traits<bool>::type flush( ::efl::eolian::in_traits<bool>::type may_block,  ::efl::eolian::in_traits<bool>::type ignore_line_delimiter) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_BUFFERED_STREAM_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct write_finished_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_WRITE_FINISHED; }
      typedef void parameter_type;
   } const write_finished_event;
   static struct read_finished_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_READ_FINISHED; }
      typedef void parameter_type;
   } const read_finished_event;
   static struct finished_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_FINISHED; }
      typedef void parameter_type;
   } const finished_event;
   static struct error_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_ERROR; }
      typedef Eina_Error parameter_type;
   } const error_event;
   static struct progress_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_PROGRESS; }
      typedef void parameter_type;
   } const progress_event;
   static struct slice_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_SLICE_CHANGED; }
      typedef void parameter_type;
   } const slice_changed_event;
   static struct line_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_BUFFERED_STREAM_EVENT_LINE; }
      typedef Eina_Slice const& parameter_type;
   } const line_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Buffered_Stream,  ::efl::Loop_User,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Reader,  ::efl::io::Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Buffered_Stream const ,  ::efl::Loop_User const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Reader const ,  ::efl::io::Writer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Buffered_Stream) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Buffered_Stream>::value, "");
} } 
#endif
