#ifndef EFL_IO_QUEUE_EO_HH
#define EFL_IO_QUEUE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_io_closer.eo.h"
#include "efl_io_queue.eo.h"
#include "efl_io_reader.eo.h"
#include "efl_io_writer.eo.h"
#include "efl_object.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_io_closer.eo.hh"
#include "efl_io_reader.eo.hh"
#include "efl_io_writer.eo.hh"
#include "efl_object.eo.hh"
namespace efl { namespace io { 
struct Queue;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::io::Queue> : ::std::true_type {}; } }
namespace efl { namespace io { 
struct Queue;
} } 
namespace efl { 
struct Object;
} 
namespace efl { namespace io { 
struct Reader;
} } 
namespace efl { namespace io { 
struct Writer;
} } 
namespace efl { namespace io { 
struct Closer;
} } 

namespace eo_cxx {
namespace efl { namespace io { 
struct Queue {
   ::efl::eolian::return_traits< size_t>::type limit_get() const;
   ::efl::eolian::return_traits<void>::type limit_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type usage_get() const;
   ::efl::eolian::return_traits<Eina_Slice>::type slice_get() const;
   ::efl::eolian::return_traits<void>::type preallocate( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits<void>::type discard( ::efl::eolian::in_traits< size_t>::type amount) const;
   ::efl::eolian::return_traits<void>::type clear() const;
   ::efl::eolian::return_traits<void>::type eos_mark() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_QUEUE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::io::Queue() const;
   operator ::efl::io::Queue&();
   operator ::efl::io::Queue const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Queue,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Reader,  ::efl::io::Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Queue const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Reader const ,  ::efl::io::Writer const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace io { 
struct Queue : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Object)
   , EO_CXX_INHERIT( ::efl ::io::Closer)
   , EO_CXX_INHERIT( ::efl ::io::Reader)
   , EO_CXX_INHERIT( ::efl ::io::Writer)
{
   explicit Queue( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Queue(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Queue(Queue const& other) = default;
   Queue(Queue&& other) = default;
   Queue& operator=(Queue const& other) = default;
   Queue& operator=(Queue&& other) = default;
   Queue()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Queue( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Queue(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits< size_t>::type limit_get() const;
   ::efl::eolian::return_traits<void>::type limit_set( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits< size_t>::type usage_get() const;
   ::efl::eolian::return_traits<Eina_Slice>::type slice_get() const;
   ::efl::eolian::return_traits<void>::type preallocate( ::efl::eolian::in_traits< size_t>::type size) const;
   ::efl::eolian::return_traits<void>::type discard( ::efl::eolian::in_traits< size_t>::type amount) const;
   ::efl::eolian::return_traits<void>::type clear() const;
   ::efl::eolian::return_traits<void>::type eos_mark() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_IO_QUEUE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct slice_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_IO_QUEUE_EVENT_SLICE_CHANGED; }
      typedef void parameter_type;
   } const slice_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Queue,  ::efl::Object,  ::efl::io::Closer,  ::efl::io::Reader,  ::efl::io::Writer> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Queue const ,  ::efl::Object const ,  ::efl::io::Closer const ,  ::efl::io::Reader const ,  ::efl::io::Writer const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Queue) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Queue>::value, "");
} } 
#endif
