#ifndef EFL_PACK_GRID_EO_HH
#define EFL_PACK_GRID_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_container.eo.h"
#include "efl_gfx.eo.h"
#include "efl_pack.eo.h"
#include "efl_pack_grid.eo.h"
#include "efl_pack_linear.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_container.eo.hh"
#include "efl_gfx.eo.hh"
#include "efl_pack.eo.hh"
#include "efl_pack_linear.eo.hh"
namespace efl { namespace pack { 
struct Grid;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::pack::Grid> : ::std::true_type {}; } }
namespace efl { namespace pack { 
struct Grid;
} } 
namespace efl { namespace pack { 
struct Linear;
} } 
namespace efl { 
struct Pack;
} 
namespace efl { 
struct Container;
} 
namespace efl { 
struct Gfx;
} 

namespace eo_cxx {
namespace efl { namespace pack { 
struct Grid {
   ::efl::eolian::return_traits<bool>::type grid_position_get( ::efl::eolian::in_traits< ::efl::Gfx>::type subobj,  ::efl::eolian::out_traits<int>::type col,  ::efl::eolian::out_traits<int>::type row,  ::efl::eolian::out_traits<int>::type colspan,  ::efl::eolian::out_traits<int>::type rowspan) const;
   ::efl::eolian::return_traits<void>::type grid_size_get( ::efl::eolian::out_traits<int>::type cols,  ::efl::eolian::out_traits<int>::type rows) const;
   ::efl::eolian::return_traits<void>::type grid_size_set( ::efl::eolian::in_traits<int>::type cols,  ::efl::eolian::in_traits<int>::type rows) const;
   ::efl::eolian::return_traits<int>::type grid_columns_get() const;
   ::efl::eolian::return_traits<void>::type grid_columns_set( ::efl::eolian::in_traits<int>::type cols) const;
   ::efl::eolian::return_traits<int>::type grid_rows_get() const;
   ::efl::eolian::return_traits<void>::type grid_rows_set( ::efl::eolian::in_traits<int>::type rows) const;
   ::efl::eolian::return_traits<void>::type grid_orientation_get( ::efl::eolian::out_traits<Efl_Orient>::type primary,  ::efl::eolian::out_traits<Efl_Orient>::type secondary) const;
   ::efl::eolian::return_traits<void>::type grid_orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type primary,  ::efl::eolian::in_traits<Efl_Orient>::type secondary) const;
   ::efl::eolian::return_traits<bool>::type pack_grid( ::efl::eolian::in_traits< ::efl::Gfx>::type subobj,  ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type colspan,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type rowspan) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type grid_contents_get( ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row,  ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type below) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type grid_content_get( ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_PACK_GRID_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::pack::Grid() const;
   operator ::efl::pack::Grid&();
   operator ::efl::pack::Grid const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Grid,  ::efl::Container,  ::efl::Gfx,  ::efl::Pack,  ::efl::pack::Linear> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Grid const ,  ::efl::Container const ,  ::efl::Gfx const ,  ::efl::Pack const ,  ::efl::pack::Linear const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace pack { 
struct Grid : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Container)
   , EO_CXX_INHERIT( ::efl::Gfx)
   , EO_CXX_INHERIT( ::efl::Pack)
   , EO_CXX_INHERIT( ::efl ::pack::Linear)
{
   explicit Grid( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Grid(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Grid(Grid const& other) = default;
   Grid(Grid&& other) = default;
   Grid& operator=(Grid const& other) = default;
   Grid& operator=(Grid&& other) = default;
   Grid()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Grid( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Grid(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type grid_position_get( ::efl::eolian::in_traits< ::efl::Gfx>::type subobj,  ::efl::eolian::out_traits<int>::type col,  ::efl::eolian::out_traits<int>::type row,  ::efl::eolian::out_traits<int>::type colspan,  ::efl::eolian::out_traits<int>::type rowspan) const;
   ::efl::eolian::return_traits<void>::type grid_size_get( ::efl::eolian::out_traits<int>::type cols,  ::efl::eolian::out_traits<int>::type rows) const;
   ::efl::eolian::return_traits<void>::type grid_size_set( ::efl::eolian::in_traits<int>::type cols,  ::efl::eolian::in_traits<int>::type rows) const;
   ::efl::eolian::return_traits<int>::type grid_columns_get() const;
   ::efl::eolian::return_traits<void>::type grid_columns_set( ::efl::eolian::in_traits<int>::type cols) const;
   ::efl::eolian::return_traits<int>::type grid_rows_get() const;
   ::efl::eolian::return_traits<void>::type grid_rows_set( ::efl::eolian::in_traits<int>::type rows) const;
   ::efl::eolian::return_traits<void>::type grid_orientation_get( ::efl::eolian::out_traits<Efl_Orient>::type primary,  ::efl::eolian::out_traits<Efl_Orient>::type secondary) const;
   ::efl::eolian::return_traits<void>::type grid_orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type primary,  ::efl::eolian::in_traits<Efl_Orient>::type secondary) const;
   ::efl::eolian::return_traits<bool>::type pack_grid( ::efl::eolian::in_traits< ::efl::Gfx>::type subobj,  ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type colspan,  ::efl::eolian::in_traits< ::efl::eina::optional<int>>::type rowspan) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Gfx>>::type grid_contents_get( ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row,  ::efl::eolian::in_traits< ::efl::eina::optional<bool>>::type below) const;
   ::efl::eolian::return_traits< ::efl::Gfx>::type grid_content_get( ::efl::eolian::in_traits<int>::type col,  ::efl::eolian::in_traits<int>::type row) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_PACK_GRID_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Grid,  ::efl::Container,  ::efl::Gfx,  ::efl::Pack,  ::efl::pack::Linear> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Grid const ,  ::efl::Container const ,  ::efl::Gfx const ,  ::efl::Pack const ,  ::efl::pack::Linear const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Grid) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Grid>::value, "");
} } 
#endif
