#ifndef EFL_UI_DRAG_EO_HH
#define EFL_UI_DRAG_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_drag.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Drag;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Drag> : ::std::true_type {}; } }
namespace efl { namespace ui { 
struct Drag;
} } 

namespace eo_cxx {
namespace efl { namespace ui { 
struct Drag {
   ::efl::eolian::return_traits<bool>::type drag_value_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_value_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_size_get( ::efl::eolian::out_traits<double>::type dw,  ::efl::eolian::out_traits<double>::type dh) const;
   ::efl::eolian::return_traits<bool>::type drag_size_set( ::efl::eolian::in_traits<double>::type dw,  ::efl::eolian::in_traits<double>::type dh) const;
   ::efl::eolian::return_traits<Efl_Ui_Drag_Dir>::type drag_dir_get() const;
   ::efl::eolian::return_traits<bool>::type drag_step_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_step_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_step_move( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_move( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DRAG_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Drag() const;
   operator ::efl::ui::Drag&();
   operator ::efl::ui::Drag const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Drag> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Drag const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Drag : ::efl::eo::concrete
{
   explicit Drag( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Drag(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Drag(Drag const& other) = default;
   Drag(Drag&& other) = default;
   Drag& operator=(Drag const& other) = default;
   Drag& operator=(Drag&& other) = default;
   Drag()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Drag( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Drag(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type drag_value_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_value_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_size_get( ::efl::eolian::out_traits<double>::type dw,  ::efl::eolian::out_traits<double>::type dh) const;
   ::efl::eolian::return_traits<bool>::type drag_size_set( ::efl::eolian::in_traits<double>::type dw,  ::efl::eolian::in_traits<double>::type dh) const;
   ::efl::eolian::return_traits<Efl_Ui_Drag_Dir>::type drag_dir_get() const;
   ::efl::eolian::return_traits<bool>::type drag_step_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_step_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_get( ::efl::eolian::out_traits<double>::type dx,  ::efl::eolian::out_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_set( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_step_move( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   ::efl::eolian::return_traits<bool>::type drag_page_move( ::efl::eolian::in_traits<double>::type dx,  ::efl::eolian::in_traits<double>::type dy) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DRAG_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Drag> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Drag const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Drag) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Drag>::value, "");
} } 
#endif
